//+------------------------------------------------------------------+
//|                                             Fractal dimesion.mq4 |
//|                                                           mladen |
//| TASC Jun 2010 - John Ehlers and Ric Way                          |
//| Fractal Dimension As A Market Mode Sensor                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DimGray
#property indicator_color2 DimGray
#property indicator_color3 DeepSkyBlue
#property indicator_style1 STYLE_DOT
#property indicator_style2 STYLE_DOT
#property indicator_width3 2

//
//
//
//
//

extern int    FDSize     = 30;
extern int    FDPrice    = PRICE_MEDIAN;
extern double FDTreshold = 1.4;

//
//
//
//
//

double FdBuffer[];
double Z1Buffer[];
double Z2Buffer[];

double wrk[][3];
int    halfSize;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,Z1Buffer); SetIndexLabel(0,NULL);
   SetIndexBuffer(1,Z2Buffer); SetIndexLabel(1,NULL);
   SetIndexBuffer(2,FdBuffer);
      
      //
      //
      //
      //
      //

      FDSize   = MathMax(FDSize,2); if (MathMod(FDSize,2)>0) FDSize++;
      halfSize = FDSize/2;
         
      //
      //
      //
      //
      //
               
   IndicatorShortName("Fractal dimension Ehlers ("+FDSize+","+DoubleToStr(FDTreshold,2)+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define _price  0
#define _smooth 1
#define _ratio  2

//
//
//
//
//

int start()
{
   double log2 = MathLog(2.0);
   int    counted_bars=IndicatorCounted();
   int    i,r,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);

   //
   //
   //
   //
   //
            
   for (i=limit, r=Bars-i-1; i>=0; i--,r++)
      {
         wrk[r][_price]  = iMA(NULL,0,1,0,MODE_SMA,FDPrice,i);
         wrk[r][_smooth] = (wrk[r][_price]+2.0*wrk[r-1][_price]+2.0+wrk[r-2][_price]+wrk[r-3][_price])/6.0;
  
         //
         //
         //
         //
         //
         
            double hh = wrk[r][_smooth];
            double ll = wrk[r][_smooth];
               for (int n=1; n<FDSize && (r-n)>0; n++)
                  {
                     hh = MathMax(hh,wrk[r-n][_smooth]);
                     ll = MathMin(ll,wrk[r-n][_smooth]);
                  }
            double n3 = (hh-ll)/FDSize;
            
         //
         //
         //
         //
         //
            
            hh = wrk[r][_smooth];
            ll = wrk[r][_smooth];
               for (n=1; n<halfSize && (r-n)>=0; n++)
                  {
                     hh = MathMax(hh,wrk[r-n][_smooth]);
                     ll = MathMin(ll,wrk[r-n][_smooth]);
                  }
            double n1 = (hh-ll)/halfSize; 

         //
         //
         //
         //
            
            hh = wrk[r-halfSize][_smooth];
            ll = wrk[r-halfSize][_smooth];
               for (n=halfSize+1; n<FDSize && (r-n)>=0; n++)
                  {
                     hh = MathMax(hh,wrk[r-n][_smooth]);
                     ll = MathMin(ll,wrk[r-n][_smooth]);
                  }
            double n2 = (hh-ll)/halfSize; 

         //
         //
         //
         //
         //
            
            if (n1>0 && n2>0 && n3>0)
                  wrk[r][_ratio] = 0.5*((MathLog(n1+n2)-MathLog(n3))/log2 + FdBuffer[i+1]);
            else  wrk[r][_ratio] = wrk[r-1][_ratio];   
                        
            double avg = wrk[r][_ratio];
            for (n=1; n<20 && (r-n)>=0; n++) avg += wrk[r-n][_ratio];
                                            avg /= n;
            FdBuffer[i] = avg;

         //
         //
         //
         //
         //

         Z1Buffer[i] = FDTreshold;
         Z2Buffer[i] = 1.6;
      }         
   return(0);
}